<?php

namespace Core;

use Core\Factory\BootstrapFactory;

class Bootstrap {

    /**
     * @var \Core\Factory\BootstrapFactory
     */
    private static BootstrapFactory $instance;

    /**
     * Start handling process
     *
     * @return \Core\Factory\BootstrapFactory
     */
    public static function createInstance(): BootstrapFactory
    {
        self::$instance = (new Bootstrap())->run();

        return Bootstrap::getInstance();
    }

    /**
     * Get the instance
     *
     * @return \Core\Factory\BootstrapFactory
     */
    public static function getInstance(): BootstrapFactory
    {
        return self::$instance;
    }

    /**
     * Create new factory instance
     *
     * @return \Core\Factory\BootstrapFactory
     */
    protected function run(): BootstrapFactory
    {
        return new BootstrapFactory();
    }
}